using System.Collections;
using System.Collections.Generic;
using Unity.VisualScripting;
using UnityEngine;
using UnityEngine.SocialPlatforms.Impl;

public class Fruits : MonoBehaviour
{
    // 0~9
    public int type;
    // 0=未移动 1=移动中 2=已释放
    private int m_isMove = 0;
    // 结束
    private bool m_isOver = false;
    public int IsMove { get => m_isMove; set => m_isMove = value; }
    // 合并GameObject
    private GameObject m_mergeObject;
    // Start is called before the first frame update
    void Start()
    {

    }

    // Update is called once per frame
    void Update()
    {
        if (IsMove != 2)
        {
            if (Input.GetMouseButtonDown(0))
                IsMove = 1;

            if (Input.GetMouseButtonUp(0) && IsMove == 1)
            {
                IsMove = 2;
                // 设置重力并创建新水果
                this.gameObject.GetComponent<Rigidbody2D>().gravityScale = 3.0f;
                GameManager.instance.InvokeCreateFruit(0.8f);
            }

            if (IsMove == 1)
            {
                // 移动
                Vector3 mousePos = Camera.main.ScreenToWorldPoint(Input.mousePosition);
                var currentPos = this.gameObject.GetComponent<Transform>().position;
                currentPos.Set(mousePos.x, currentPos.y, currentPos.z);
                this.gameObject.GetComponent<Transform>().position = currentPos;
            }
        }
        
    }
    void OnTriggerEnter2D(Collider2D other)
    {
    }
    void OnCollisionEnter2D(Collision2D collisionInfo)
    {
        if (type == 9 || m_isOver)
            return;
        if (collisionInfo.gameObject.tag != "fruits")
            return;
        if (collisionInfo.gameObject.GetComponent<Fruits>().type != this.type)
            return;
        m_mergeObject = collisionInfo.gameObject;
        m_isOver = true;
        collisionInfo.gameObject.GetComponent<Fruits>().m_isOver = true;
        Invoke("merge",0.1f);
    }
    void merge() {
        
        var newV3 = (m_mergeObject.transform.position + this.gameObject.transform.position) / 2;
        GameManager.instance.createFruitByPosition(newV3, type + 1, this.gameObject.transform);
        
        m_mergeObject.GetComponent<Fruits>().m_isOver = true;
        Destroy(this.gameObject);
        Destroy(m_mergeObject);
    }
}
